# Create a debit memo from a charge Note: This operation is only available if you have Invoice Settlement enabled. The Invoice Settlement feature is generally available as of Zuora Billing Release 296 (March 2021). This feature includes Unapplied Payments, Credit and Debit Memo, and Invoice Item Settlement. If you want to enable Invoice Settlement, see Invoice Settlement Enablement and Checklist Guide for more information. Creates an ad-hoc debit memo from a product rate plan charge. Zuora supports the creation of debit memos from any type of product rate plan charge. The charges can also have any amount and any charge model, except for discout charge models. When debit memos are created from product rate plan charges, the specified amount with decimal places is now validated based on the decimal places supported by each currency. You can create a debit memo only if you have the user permission. See Billing Roles for more information. Endpoint: POST /v1/debit-memos Version: 2026-02-20 Security: bearerAuth ## Header parameters: - `Idempotency-Key` (string) Specify a unique idempotency key if you want to perform an idempotent POST or PATCH request. Do not use this header in other request types. With this header specified, the Zuora server can identify subsequent retries of the same request using this value, which prevents the same operation from being performed multiple times by accident. - `Accept-Encoding` (string) Include the Accept-Encoding: gzip header to compress responses as a gzipped file. It can significantly reduce the bandwidth required for a response. If specified, Zuora automatically compresses responses that contain over 1000 bytes of data, and the response contains a Content-Encoding header with the compression algorithm so that your client can decompress it. - `Content-Encoding` (string) Include the Content-Encoding: gzip header to compress a request. With this header specified, you should upload a gzipped file for the request payload instead of sending the JSON payload. - `Zuora-Track-Id` (string) A custom identifier for tracing the API call. If you set a value for this header, Zuora returns the same value in the response headers. This header enables you to associate your system process identifiers with Zuora API calls, to assist with troubleshooting in the event of an issue. The value of this field must use the US-ASCII character set and must not include any of the following characters: colon (:), semicolon (;), double quote ("), and quote ('). - `Zuora-Entity-Ids` (string) An entity ID. If you have Zuora Multi-entity enabled and the OAuth token is valid for more than one entity, you must use this header to specify which entity to perform the operation in. If the OAuth token is only valid for a single entity, or you do not have Zuora Multi-entity enabled, you should not set this header. - `Zuora-Org-Ids` (string) Comma separated IDs. If you have Zuora Multi-Org enabled, you can use this header to specify which orgs to perform the operation in. If you do not have Zuora Multi-Org enabled, you should not set this header. The IDs must be a sub-set of the user's accessible orgs. If you specify an org that the user does not have access to, the operation fails. This header is important in Multi-Org (MO) setups because it defines the organization context under which the API should operate—mainly used for read access or data visibility filtering. If the header is not set, the operation is performed in scope of the user's accessible orgs. - `Zuora-Version` (string) The minor API version. For a list of available minor versions, see API upgrades. ## Request fields (application/json): - `accountId` (string) The ID of the account associated with the debit memo. Note: When creating debit memos from product rate plan charges, you must specify accountNumber, accountId, or both in the request body. If both fields are specified, they must correspond to the same account. Example: "8ad09be48db5aba7018db604776d4854" - `accountNumber` (string) The number of the account associated with the debit memo. Note: When creating debit memos from product rate plan charges, you must specify accountNumber, accountId, or both in the request body. If both fields are specified, they must correspond to the same account. - `autoPay` (boolean) Whether debit memos are automatically picked up for processing in the corresponding payment run. By default, debit memos are automatically picked up for processing in the corresponding payment run. - `autoPost` (boolean) Whether to automatically post the debit memo after it is created. Setting this field to true, you do not need to separately call the [Post a debit memo](https://developer.zuora.com/api-references/api/operation/PUT_PostDebitMemo) operation to post the debit memo. - `charges` (array) Container for product rate plan charges. The maximum number of items is 1,000. Example: [{"amount":10,"productRatePlanChargeId":"8ad097b4909708e001909b41bb085d38"}] - `charges.amount` (number) The amount of the debit memo item. Note: This field is available only if you are on the latest Zuora API minor version, or you set the Zuora-Version request header to 224.0 or [a later available version](https://developer.zuora.com/v1-api-reference/api-versions/#minor-version). - `charges.excludeItemBillingFromRevenueAccounting` (boolean) The flag to exclude the debit memo item from revenue accounting. Note: This field is only available if you have the Billing - Revenue Integration feature enabled. - `charges.description` (string) The description of the product rate plan charge. Note: This field is available only if you are on the latest Zuora API minor version, or you set the Zuora-Version request header to 257.0 or [a later available version](https://developer.zuora.com/v1-api-reference/api-versions/#minor-version). - `charges.financeInformation` (object) Container for the finance information related to the product rate plan charge associated with the debit memo. - `charges.financeInformation.deferredRevenueAccountingCode` (string,null) The accounting code for the deferred revenue, such as Monthly Recurring Liability. - `charges.financeInformation.recognizedRevenueAccountingCode` (string,null) The accounting code for the recognized revenue, such as Monthly Recurring Charges or Overage Charges. - `charges.financeInformation.revenueRecognitionRuleName` (string,null) The name of the revenue recognition rule governing the revenue schedule. - `charges.productRatePlanChargeId` (string, required) The ID of the product rate plan charge that the debit memo is created from. Note: This field is available only if you are on the latest Zuora API minor version, or you set the Zuora-Version request header to 257.0 or [a later available version](https://developer.zuora.com/v1-api-reference/api-versions/#minor-version). - `charges.quantity` (number) The number of units for the debit memo item. - `charges.serviceEndDate` (string) The service end date of the debit memo item. If not specified, the effective end date of the corresponding product rate plan will be used. - `charges.serviceStartDate` (string) The service start date of the debit memo item. If not specified, the effective start date of the corresponding product rate plan will be used. - `comment` (string) Comments about the debit memo. - `currency` (string) The code of a currency as defined in Billing Settings through the Zuora UI. If you do not specify a currency during debit memo creation, the default account currency is applied. The currency that you specify in the request must be configured and activated in Billing Settings. Note: This field is available only if you have the Multiple Currencies feature enabled. - `customRates` (array) It contains Home currency and Reporting currency custom rates currencies. The maximum number of items is 2 (you can pass the Home currency item or Reporting currency item or both). Note: - The API custom rate feature is permission controlled. - You cannot set the custom rates, if both the Automatically include additional Currency Conversion information in data source exports option and Fx data feature are enabled. - DebitMemo, DebitMemoItem, and DebitMemoItemTax will utilize the provided custom Fx rate to convert amounts from the transactional currency to the home currency. - `customRates.currency` (string, required) The currency code for either Reporting or Home currency. Note: This field is available only if you are on the latest Zuora API minor version, or you set the Zuora-Version request header to 224.0 or [a later available version](https://developer.zuora.com/v1-api-reference/api-versions/#minor-version). - `customRates.customFxRate` (number, required) The Custom FX conversion rate between home currency and transactional currency items. Note: This field is available only if you are on the latest Zuora API minor version, or you set the Zuora-Version request header to 224.0 or [a later available version](https://developer.zuora.com/v1-api-reference/api-versions/#minor-version). - `customRates.rateDate` (string) The date on which a particular currency rate is fixed or obtained on. Note: This field is available only if you are on the latest Zuora API minor version, or you set the Zuora-Version request header to 224.0 or [a later available version](https://developer.zuora.com/v1-api-reference/api-versions/#minor-version). - `dueDate` (string) The date by which the payment for the debit memo is due, in yyyy-mm-dd format. - `effectiveDate` (string) The date when the debit memo takes effect. - `number` (string) A customized debit memo number with the following format requirements: - Max length: 32 characters - Acceptable characters: a-z,A-Z,0-9,-,_ The value must be unique in the system, otherwise it may cause issues with bill runs and subscriptions. If not provided, Zuora will generate a unique number per the sequence set on the account level. If the account-level sequence set is not specified, the system default sequence set is used. For more information, see Configure prefix and numbering for billing documents. - `reasonCode` (string) A code identifying the reason for the transaction. The value must be an existing reason code or empty. If you do not specify a value, Zuora uses the default reason code. - `IntegrationId__NS` (string) ID of the corresponding object in NetSuite. Only available if you have installed the [Zuora Connector for NetSuite](https://www.zuora.com/connect/app/?appId=265). - `IntegrationStatus__NS` (string) Status of the debit memo's synchronization with NetSuite. Only available if you have installed the [Zuora Connector for NetSuite](https://www.zuora.com/connect/app/?appId=265). - `SyncDate__NS` (string) Date when the debit memo was synchronized with NetSuite. Only available if you have installed the [Zuora Connector for NetSuite](https://www.zuora.com/connect/app/?appId=265). ## Response 200 fields (application/json): - `accountId` (string) The ID of the customer account associated with the debit memo. - `accountNumber` (string) The number of the customer account associated with the debit memo. - `amount` (number) The total amount of the debit memo. - `autoPay` (boolean) Whether debit memos are automatically picked up for processing in the corresponding payment run. By default, debit memos are automatically picked up for processing in the corresponding payment run. - `balance` (number) The balance of the debit memo. - `beAppliedAmount` (number) The amount that is applied to the debit memo. - `billToContactId` (string) The ID of the bill-to contact associated with the debit memo. The value of this field is null if you have the [Flexible Billing Attributes](https://docs.zuora.com/en/zuora-billing/bill-your-customer/leverage-advanced-capabilities/flexible-billing/flexible-billing-attributes/overview-of-flexible-billing-attributes) feature disabled. - `billToContactSnapshotId` (string) The ID of the bill-to contact snapshot associated with the debit memo. The value of this field is null if the bill rule [Preserve snapshot of bill-to and sold-to contacts when billing documents are posted](https://knowledgecenter.zuora.com/Zuora_Billing/Billing_and_Invoicing/Billing_Settings/Define_Billing_Rules#Preserve_snapshot_of_bill-to_and_sold-to_contacts_when_billing_documents_are_posted) is disabled. - `cancelledById` (string,null) The ID of the Zuora user who cancelled the debit memo. - `cancelledOn` (string,null) The date and time when the debit memo was cancelled, in yyyy-mm-dd hh:mm:ss format. - `currency` (string,null) The currency of the debit memo. Note: By default, the currency on a billing document matches the default currency set on the associated account. However, Zuora now offers a Multiple Currencies feature to support different currencies for billing documents, allowing flexibility beyond the account-level currency. For more information, see Multiple Currency. - `comment` (string,null) Comments about the debit memo. - `createdById` (string) The ID of the Zuora user who created the debit memo. - `createdDate` (string) The date and time when the debit memo was created, in yyyy-mm-dd hh:mm:ss format. For example, 2017-03-01 15:31:10. - `debitMemoDate` (string) The date when the debit memo takes effect, in yyyy-mm-dd format. For example, 2017-05-20. - `dueDate` (string) The date by which the payment for the debit memo is due, in yyyy-mm-dd format. - `einvoiceErrorCode` (string,null) The error code returned when the e-invoice file status is Failed. This code can either be a Zuora-generated error code or one returned by a third-party e-invoicing service provider. Note: This field is available only if you have the E-Invoicing feature in Early Adopter phase enabled. - `einvoiceErrorMessage` (string,null) The error message returned when the e-invoice file status is Failed. This message can either be a Zuora-generated error message or one returned by a third-party e-invoicing service provider. Note: This field is available only if you have the E-Invoicing feature in Early Adopter phase enabled. - `einvoiceFileId` (string,null) The ID of the e-invoice file generated for the debit memo. Note: This field is available only if you have the E-Invoicing feature in Early Adopter phase enabled. - `einvoiceStatus` (string,null) The status of the e-invoice file generation for the debit memo. - If e-invoice file generation succeeds, this field is either Generated or Success, and both the error code and message are empty, and the eInvoiceFileId field stores the ID of the generated e-invoice file. - If the responses from tax vendors such as Sovos or Avalara are taking too long, this field becomes RetrieveTimeOut. Once the vendor responds successfully, you can use the 'Resync E-Invoice Status' action to update the status automatically. You can view these updates in System Health telemetry. - If a failure occurs during e-invoice file generation, this field is Failed and an error code and an error message are returned respectively in the einvoiceErrorCode and einvoiceErrorMessage fields. - If e-invoice file generation conditionally succeeds, this field is ConditionalSuccess and an error code and an error message are returned respectively in the einvoiceErrorCode and einvoiceErrorMessage fields. - If the e-invoice file has been approved by the tax authority, this field is ApprovedByAuthority. The next status will be either Success or Rejected. - If the e-invoice file has been rejected by the government, this field is Rejected. You cannot resend this e-invoice; you must create a new invoice instead. Note: This field is available only if you have the E-Invoicing feature in Early Adopter phase enabled. Enum: "Processing", "RetrieveTimeOut", "Generated", "Success", "Failed", "ConditionalSuccess", "ApprovedByAuthority", "Rejected" - `excludeItemBillingFromRevenueAccounting` (boolean) The flag to exclude the debit memo item from revenue accounting. Note: This field is only available if you have the Billing - Revenue Integration feature enabled. - `id` (string) The unique ID of the debit memo. - `invoiceGroupNumber` (string,null) The number of the invoice group associated with the debit memo. The value of this field is null if you have the [Flexible Billing Attributes](https://docs.zuora.com/en/zuora-billing/bill-your-customer/leverage-advanced-capabilities/flexible-billing/flexible-billing-attributes/overview-of-flexible-billing-attributes) feature disabled. - `latestPDFFileId` (string) The ID of the latest PDF file generated for the debit memo. - `number` (string) The unique identification number of the debit memo. - `organizationLabel` (string) The organization that this object belongs to. Note: This field is available only when the Multi-Org feature is enabled. - `paymentTerm` (string) The name of the payment term assoicated with the debit memo. The value of this field is null if you have the [Flexible Billing Attributes](https://docs.zuora.com/en/zuora-billing/bill-your-customer/leverage-advanced-capabilities/flexible-billing/flexible-billing-attributes/overview-of-flexible-billing-attributes) feature disabled. - `postedById` (string,null) The ID of the Zuora user who posted the debit memo. - `postedOn` (string,null) The date and time when the debit memo was posted, in yyyy-mm-dd hh:mm:ss format. - `reasonCode` (string) A code identifying the reason for the transaction. The value must be an existing reason code or empty. - `referredCreditMemoId` (string) The ID of the credit memo from which the debit memo was created. - `referredInvoiceId` (string,null) The ID of a referred invoice. - `sequenceSetId` (string,null) The ID of the sequence set associated with the debit memo. The value of this field is null if you have the [Flexible Billing Attributes](https://docs.zuora.com/en/zuora-billing/bill-your-customer/leverage-advanced-capabilities/flexible-billing/flexible-billing-attributes/overview-of-flexible-billing-attributes) feature disabled. - `communicationProfileId` (string,null) The ID of the communication profile associated with the debit memo. Note: This field is available in the request body only if you have the Flexible Billing Attributes feature turned on. The value is null in the response body without this feature turned on. - `soldToContactId` (string,null) The ID of the sold-to contact associated with the debit memo. The value of this field is null if you have the Flexible Billing Attributes feature disabled. - `soldToContactSnapshotId` (string,null) The ID of the sold-to contact snapshot associated with the debit memo. The value of this field is null if you have the Flexible Billing Attributes feature disabled. - `sourceType` (string) The type of the debit memo source. Enum: "Subscription", "Standalone", "Order", "Consolidation", "Invoice", "CreditMemo" - `status` (string) The status of the debit memo. Enum: "Draft", "Posted", "Canceled", "Error", "PendingForTax", "Generating", "CancelInProgress" - `success` (boolean) Returns true if the request was processed successfully. - `targetDate` (string,null) The target date for the debit memo, in yyyy-mm-dd format. For example, 2017-07-20. - `taxAmount` (number) The amount of taxation. - `taxMessage` (string,null) The message about the status of tax calculation related to the debit memo. If tax calculation fails in one debit memo, this field displays the reason for the failure. - `taxStatus` (string,null) The status of tax calculation related to the debit memo. Note: This field is only applicable to tax calculation by third-party tax engines. Also, the Voided status indicates that the tax transaction is successfully canceled on the tax vendor's side. If a tax transaction was successfully committed to the third-party tax engine but the invoice failed to post, Zuora automatically detects the issue and voids the tax transaction on the vendor's side. Enum: "Complete", "Error", "UnknownError", "DuplicateDoc", "InvalidRequest", "InvalidResponse", "TaxEngineError", "ConcurrentModify", "InternalServerError", "TaxCodeTemplateError", "Voided" - `totalTaxExemptAmount` (number) The calculated tax amount excluded due to the exemption. - `transferredToAccounting` (string) Whether the debit memo was transferred to an external accounting system. Use this field for integration with accounting systems, such as NetSuite. Enum: "Processing", "Yes", "No", "Error", "Ignore" - `updatedById` (string) The ID of the Zuora user who last updated the debit memo. - `updatedDate` (string) The date and time when the debit memo was last updated, in yyyy-mm-dd hh:mm:ss format. For example, 2017-03-02 15:36:10. - `IntegrationId__NS` (string) ID of the corresponding object in NetSuite. Only available if you have installed the [Zuora Connector for NetSuite](https://www.zuora.com/connect/app/?appId=265). - `IntegrationStatus__NS` (string) Status of the debit memo's synchronization with NetSuite. Only available if you have installed the [Zuora Connector for NetSuite](https://www.zuora.com/connect/app/?appId=265). - `SyncDate__NS` (string) Date when the debit memo was synchronized with NetSuite. Only available if you have installed the [Zuora Connector for NetSuite](https://www.zuora.com/connect/app/?appId=265). ## Response 500 fields (application/json): - `reasons` (array) Example: [{"code":"ObjectNotFound","message":"Notification definition with id 6e569e1e05f040eda51a927b140c0ac1 does not exist"}] - `reasons.code` (string) The error code of response. - `reasons.message` (string) The detail information of the error response ## Response 4XX fields (application/json): - `processId` (string) The ID of the process that handles the operation. - `reasons` (array) The container of the error code and message. This field is available only if the success field is false. - `reasons.code` (string) The error code of response. - `reasons.message` (string) The detail information of the error response - `requestId` (string) Unique identifier of the request. - `success` (boolean) Indicates whether the call succeeded.